package flow

// RefType data type
//type RefType int

// Reference types
const (
//RefConst = RefType(1) + iota
//RefData
//RefFunc
//RefAttr
)

// Referer interface
type Ref interface {
	_ref() ref
}

// Ref flow object reference
type ref struct {
	flow *Flow
	id   int // ref index
}

// Return self for interface
// ref ref ref ref ref
func (r ref) _ref() ref {
	return r
}

type RefFunc struct{ ref }
type RefConst struct{ ref }
type RefVar struct{ ref }

func (r RefVar) Set(value interface{}) {
	r.flow.data[r.id] = value
}
